////////////////////////////////////////////////////////////////////////
////  CHANNEL CONTROL DIALOG AND EVENTS & FUNCTIONS ///////
////////////////////////////////////////////////////////////////////////
// Changes /channel to my control dialog
alias channel control

// Initializes the dialog
alias Control { var %i = $dialog(control,control) }

// Control dialog table
dialog control {
  title "Controls"
  size 				-1 -1 298 230
  tab "nicks"			1,1 1 295 200
  tab "topic"			2
  tab "modes"			3
  tab "bans" 			104
  button "&OK"			4,100 202 75 25,ok

  list 				5,6 29 100 180,tab1 vsbar extsel
  box "actions:"			6,115 27 170 160,tab1
  radio "+o "			7,125 45 30 17,tab1 group
  radio "-o "			8,125 62 30 17,tab1 
  radio "cs +o "			9,170 45 45 17,tab1
  radio "cs -o "			10,170 62 45 17,tab1
  radio "+v "			11,225 45 30 17,tab1
  radio "-v "			12,225 62 30 17,tab1
  radio "+b "			13,125 79 30 17,tab1
  radio "/k +b "			14,170 79 45 17,tab1
  radio "/k "			15,225 79 30 17,tab1
  text "total nicks:"			16,125 96 70 15,tab1
  text ""				17,180 96 30 15,tab1
  text "sel:"			18,210 96 20 15,tab1
  text "0"				19,230 96 20 15,tab1
  text "action:"			20,125 110 35 15,tab1
  text "mass op"			21,165 110 100 15,tab1
  button "do action"			22,125 132 150 25,tab1
  text "select all:"			23,125 165 50 15,tab1
  button "op's"			24,175 165 30 15,tab1
  button "vo's"			25,210 165 30 15,tab1
  button "reg's"			26,245 165 30 15,tab1

  ;<=- not enabled -=>
  box "topic:"			27,9 29 280 84,tab2
  edit "" 				28,18 44 262 60,tab2 vsbar multi
  box "signature:"			29,9 120 280 40,tab2
  check "enable" 			30,18 135 60 20,tab2
  radio "nick"			31,90 135 50 20,tab2 group disable
  radio "script"			32,150 135 50 20,tab2 disable
  radio "both"			33,210 135 50 20,tab2 disable
  button "change topic"		49,90 167 95 20,tab2

  check "&private (+p)" 		34,30 40 100 20,tab3
  check "&invite (+i)"		35,30 65 100 20,tab3
  check "&no ext. msgs (+n)"		36,30 90 100 20,tab3
  check "&moderated (+m)"		37,30 115 100 20,tab3
  check "&key (+k):"		38,30 140 60 20,tab3
  edit ""				39,90 140 50 20,tab3 autohs disable
  check "&Regged nicks (+R)"	40,160 40 110 20,tab3
  check "no &colors (+c)"		41,160 65 100 20,tab3
  check "op &topic (+t)"		42,160 90 100 20,tab3
  check "&secret (+s)"		43,160 115 100 20,tab3
  check "&limit to (+l):"		44,160 140 70 20,tab3
  edit ""				45,230 140 50 20,tab3 disable
  text "preview:"			46,20 172 50 15,tab3
  edit ""				47,70 170 150 20,tab3 read autohs
  button "set modes"		48,230 170 60 20,tab3

  list 				50,6 29 285 140,tab104 hsbar vsbar sort extsel
  box "actions:" 			51,6 153 286 40,tab104
  button "refresh"			52,20 168 50 18,tab104
  button "select all"			53,120 168 50 18,tab104
  button "remove"			54,220 168 50 18,tab104
}

// ; : : : : : : : : : : : : : : : : : : modes: pinkmRctsl

// Control dialog events
on *:dialog:control:*:*: {
  if ($devent = init) {
    did -c control 7 
    c.list
    did -o control 17 1 $did(5,0).sel
    did -a control 28 $chan($active).topic
    c.rfs.m
    c.upd
    if ($settings.get(other,sigon)) { did -c control 30 }
    did -c control $settings.get(other,signature)
    if (($chr(35) isin $active) && ($server)) { c.bans }
  }
  if ($devent = sclick) { 
    if ($did = 54) { bans.rem }
    if ($did = 53) { c.selall }
    if ($did = 52) { c.bans }
    if ($did = 49) { topic $active $c.t.get }
    if ($did = 30) { settings.set other sigon $did(control,30).state }
    if (($did >= 31) && ($did <= 33)) { 
      if ($did(control,31).state) { settings.set other signature 31 }
      if ($did(control,32).state) { settings.set other signature 32 }
      if ($did(control,33).state) { settings.set other signature 33 }
    }
    if ($did = 24) { c.sel o | did -o control 19 1 $did(5,0).sel }
    if ($did = 25) { c.sel v | did -o control 19 1 $did(5,0).sel }
    if ($did = 26) { c.sel r | did -o control 19 1 $did(5,0).sel }
    if ($did = 22) { 
      if ($did(14).state) { 
        m.action action(mode $active +bbbbbb) $didsel
        m.action action(kick $active ) $didsel
      }
      else m.action action( $+ $m.da $+ ) $didsel
    }
    if ($did = 5) { did -o control 19 1 $did(5,0).sel }
    if ($did = 48) { c.m.rtn set }
    did -o control 21 1 $remove($m.hlp,$2)
    c.upd
    c.m.rtn
  }
  if (($devent = edit) && (($did = 39) || ($did = 45))) { c.m.rtn }
  if ($devent = dclick) {  } 
  ;refresh 5 (listbox)
}

/////////////////////////////////////////////////////////////////////////////////////////
// Function does a mass action						//
//									//
// 	/m.action action(<action>) <nick1,nick2,...,nickN>				//
// 	nicks are sepearted by comma's "," $chr(44)				//
// 	$snicks = nick1,nick2,...,nickN					//
//									//
/////////////////////////////////////////////////////////////////////////////////////////
alias m.action {
  if ($left($1,6) = action) {
    var %ma = $gettok($gettok($1-,2,40),1,41)
    set %s %ma
    var %ns = $gettok($1-,-1,41)
    var %tn = $numtok(%ns,44)
    if (%tn <= $s) { %ma $replace(%ns,$chr(44),$chr(32)) | return }
    else { while (%tn > 0) {
        var %r = $gettok(%ns,1- [ $+ [ $s ] ] ,44)
        %ma $replace(%r,$chr(44),$chr(32))
        var %ns = $deltok(%ns,1- [ $+ [ $s ] ] ,44)
        dec %tn $s
    } }
    unset %s | return
  }
  else { echo -a /m.action action(<action>) <nick1,nick2,...,nickN> }
}

// Returns how many actions can be taken
alias -l s { if ((mode isin %s) || (op isin %s)) { return $iif(((dal.net isin $server) || (!$server)),6,3) } | else { return 1 } }

// Returns list of nicks in channel or fills dialog's list with them
alias c.list {
  var %i = 1
  var %a = $active
  var %ns = $nick(%a,1)
  while (%i <= $nick(%a,0)) {
    if ($isid) { var %ns = %ns $nick(%a,%i) }
    else { did -a control 5 $nick(%a,%i) }
    inc %i
  }
  if ($isid) { return $replace(%ns,$chr(32),$chr(44)) }
}

// Return a helpfull note on what your trying to do
alias m.hlp {
  var %+o = $did(control,7).state | var %-o = $did(control,8).state | var %k = $did(control,15).state 
  var %+v = $did(control,11).state | var %-v = $did(control,12).state | var %+b = $did(control,13).state
  var %k.+b = $did(control,14).state
  var %cs.+o = $did(control,9).state
  var %cs.-o = $did(control,10).state
  if (%+o) { return mass op }
  if (%-o) { return mass deop }
  if (%cs.+o) { return chanserv op }
  if (%cs.-o) { return chanserv deop }
  if (%+v) { return  mass voice }
  if (%-v) { return mass devoice }
  if (%+b) { return mass ban }
  if (%k.+b) { return mass kick/ban }
  if (%k) { return mass kick }
}

// Returns actions to take
alias m.da {
  var %+o = $did(control,7).state | var %-o = $did(control,8).state | var %k = $did(control,15).state 
  var %+v = $did(control,11).state | var %-v = $did(control,12).state | var %+b = $did(control,13).state
  var %k.+b = $did(control,14).state
  var %cs.+o = $did(control,9).state
  var %cs.-o = $did(control,10).state
  if (%+o = 1) { return mode $active +oooooo }
  if (%-o = 1) { return mode $active -oooooo }
  if (%cs.+o = 1) { return cs op $active }
  if (%cs.-o = 1) { return cs deop $active }
  if (%+v = 1) { return mode $active +vvvvvv }
  if (%-v = 1) { return mode $active -vvvvvv }
  if (%+b = 1) { return mode $active +bbbbbb }
  if (%k.+b = 1) { return mode $active +bbbbbb && kick }
  if (%k = 1) { return kick $active }
}

// Returns selected nicks
alias didsel {
  var %t = $did(control,5,0).sel
  var %r = $did(control,5,$did(control,5,%t).sel).text | dec %t
  while (%t > 0) {
    var %r = %r $+ , $+ $did(control,5,$did(control,5,%t).sel).text
    dec %t
  }
  return %r
}

// Selects all ops, voices, or regular users
alias c.sel {
  var %o = $nick($active,0,o),%v = $calc($nick($active,0,v,o) + %o),%vs = $calc(%o + 1),%r = $nick($active,0),%rs = $calc(%v + 1),%i = 1
  if (($1 = o) && (%o)) { while (%i <= %o) { did -kc control 5 %i | inc %i } }
  if (($1 = v) && ($nick($active,0,v,o))) { var %i = %vs | while (%i <= %v) { did -kc control 5 %i | inc %i } }
  if (($1 = r) && ($nick($active,0,r,vo))) { var %i = %rs | while (%i <= %r) { did -kc control 5 %i | inc %i } }
}

// Checks the required boxes for modes
alias c.rfs.m {
  var %m = $chan($active).mode
  if (p isin %m) { did -c control 34 }
  if (i isin %m) { did -c control 35 }
  if (n isin %m) { did -c control 36 }
  if (m isin %m) { did -c control 37 }
  if (R isin %m) { did -c control 40 }
  if (c isin %m) { did -c control 41 }
  if (t isin %m) { did -c control 42 }
  if (s isin %m) { did -c control 43 }
  if (k isin %m) { 
    if (l isin %m) { 
      if ($pos(%m,l,1) < $pos(%m,k,1)) { did -o control 45 1 $gettok(%m,2,32) | did -o control 39 1 $gettok(%m,3,32) }
      else { did -o control 45 1 $gettok(%m,3,32) | did -o control 39 1 $gettok(%m,2,32) }
      did -c control 44 | did -c control 38 
    } 
    else { 
      did -c control 38
      did -o control 39 1 $gettok(%m,2,32)
    } 
  }
  elseif (l isin %m) { 
    did -o control 45 1 $gettok(%m,2,32) 
    did -c control 44
  }
}

// Changes the editbox to active or inactive if box is checked or not
alias c.upd {
  if ($did(control,38).state) { did -e control 39 } | else { did -b control 39 }
  if ($did(control,44).state) { did -e control 45 } | else { did -b control 45 }
  if ($did(control,30).state) { did -e control 31 | did -e control 32 | did -e control 33 } 
  else { did -b control 31 | did -b control 32 | did -b control 33 }
}

// Changes mode in active channel to ones checked
alias c.m.rtn {
  var %1,%2,%ext
  if ($did(control,34).state) { var %1 = %1 $+ +p } | else { var %1 = %1 $+ -p }
  if ($did(control,35).state) { var %1 = %1 $+ +i } | else { var %1 = %1 $+ -i }
  if ($did(control,36).state) { var %1 = %1 $+ +n } | else { var %1 = %1 $+ -n }
  if ($did(control,37).state) { var %1 = %1 $+ +m } | else { var %1 = %1 $+ -m }
  if ($did(control,40).state) { var %1 = %1 $+ +R } | else { var %1 = %1 $+ -R }
  if ($did(control,41).state) { var %2 = %2 $+ +c } | else { var %2 = %2 $+ -c }
  if ($did(control,42).state) { var %2 = %2 $+ +t } | else { var %2 = %2 $+ -t }
  if ($did(control,43).state) { var %2 = %2 $+ +s } | else { var %2 = %2 $+ -s }
  if ($did(control,38).state) { var %2 = %2 $+ +k | var %ext = $replace($did(control,39).text,$chr(32),_) }
  else { var %2 = %2 $+ -k | var %ext = $iif($replace($did(control,39).text,$chr(32),_),$replace($did(control,39).text,$chr(32),_),bleh) }
  if ($did(control,44).state) { var %2 = %2 $+ +l | var %ext = %ext $gettok($did(control,45).text,1,32) }
  else { var %2 = %2 $+ -l | var %ext = %ext $gettok($did(control,45).text,1,32) }
  if ($1 = set) {
    mode $active %1
    mode $active %2 %ext 
  }
  did -o control 47 1 %1 %2 %ext
}

// Returns new topic with signature if thats enabled
alias c.t.get {
  var %t = $did(control,28).lines
  var %i = 1
  var %r
  while (%i <= %t) {
    var %r = %r $did(control,28,%i).text
    inc %i
  }
  if ($settings.get(other,sigon)) {
    if ($settings.get(other,signature) = 31) { var %r = %r - $me }
    if ($settings.get(other,signature) = 32) { var %r = %r - $logo }
    if ($settings.get(other,signature) = 33) { var %r = %r - $me $+ / $+ $logo }
  }
  return %r
}

// Removes slected bans
alias bans.rem {
  var %r = $bans.didsel
  m.action action(mode $active -bbbbbb) %r
}

// Selects all bans
alias c.selall { 
  var %i = $did(control,50).lines
  while (%i > 0) {
    did -kc control 50 %i
    dec %i
  }
}

// Fills up ban list
alias c.bans {
  .enable #bans
  mode $active +b
}

// Events for /bans
#bans off
raw 367:*: { did -a control 50 $3 | halt }
raw 368:*: { .disable #bans | halt }
#bans end
raw 367:*: halt
raw 368:*: halt

// Function returns list of bans selected
alias bans.didsel {
  var %t = $did(control,50,0).sel
  var %r = $did(control,50,$did(control,50,%t).sel).text | dec %t
  while (%t > 0) {
    var %r = %r $+ , $+ $did(control,50,$did(control,50,%t).sel).text
    dec %t
  }
  return %r
}
